'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));
var styled = _interopDefault(require('styled-components'));
var classNames = _interopDefault(require('classnames'));
var Prism = _interopDefault(require('prismjs'));

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
}

function __decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}

























function __makeTemplateObject(cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
}

var withStyle = function (Self) { return styled(Self)(templateObject_1 || (templateObject_1 = __makeTemplateObject([""], [""]))); };
var CodeBlock = /** @class */ (function (_super) {
    __extends(CodeBlock, _super);
    function CodeBlock() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CodeBlock.prototype.render = function () {
        var _a = this.props, className = _a.className, _b = _a.attributes, externalClassName = _b.className, attributes = __rest(_b, ["className"]), children = _a.children;
        return (React.createElement("div", __assign({}, {
            className: classNames(externalClassName, className),
        }),
            React.createElement("pre", null,
                React.createElement("code", __assign({}, attributes), children))));
    };
    CodeBlock = __decorate([
        withStyle
    ], CodeBlock);
    return CodeBlock;
}(React.Component));
var templateObject_1;

var coder = function (options) {
    if (options === void 0) { options = {}; }
    var getContent = function (token) {
        if (typeof token === 'string') {
            return token;
        }
        else if (typeof token.content === 'string') {
            return token.content;
        }
        else {
            return token.content.map(getContent).join('');
        }
    };
    var renderBlock = function (props, editor, next) {
        var node = props.node;
        if (node.type === 'code') {
            return React.createElement(CodeBlock, __assign({}, props));
        }
        return next();
    };
    var renderDecoration = function (props, editor, next) {
        var children = props.children, decoration = props.decoration, attributes = props.attributes;
        // console.log(decoration.type)
        switch (decoration.type) {
            case 'string':
                return (React.createElement("span", __assign({}, attributes, { style: { color: 'green' } }), children));
            case 'comment':
                return (React.createElement("span", __assign({}, attributes, { style: { opacity: '0.33' } }), children));
            case 'keyword':
                return (React.createElement("span", __assign({}, attributes, { style: { fontWeight: 'bold' } }), children));
            case 'tag':
                return (React.createElement("span", __assign({}, attributes, { style: { fontWeight: 'bold' } }), children));
            case 'punctuation':
                return (React.createElement("span", __assign({}, attributes, { style: { opacity: '0.75' } }), children));
            default:
                return next();
        }
    };
    var onKeyDown = function (event, editor, next) {
        var value = editor.value;
        if (event.key === 'Enter' && value.startBlock.type === 'code') {
            event.preventDefault();
            editor.insertText('\n');
            return;
        }
        next();
    };
    var decorateNode = function (node, editor, next) {
        var others = next() || [];
        if (node.type !== 'code')
            return others;
        var language = node.data.get('language');
        if (!language)
            return others;
        var texts = Array.from(node.texts());
        var string = texts.map(function (_a) {
            var n = _a[0];
            return n.text;
        }).join('\n');
        var grammar = Prism.languages[language];
        var tokens = Prism.tokenize(string, grammar);
        var decorations = [];
        var startEntry = texts.shift();
        var endEntry = startEntry;
        var startOffset = 0;
        var endOffset = 0;
        for (var _i = 0, tokens_1 = tokens; _i < tokens_1.length; _i++) {
            var token = tokens_1[_i];
            startEntry = endEntry;
            startOffset = endOffset;
            var _a = startEntry, startText = _a[0], startPath = _a[1];
            var content = getContent(token);
            // const newlines = content.split('\n').length - 1
            var length = content.length; // - newlines
            var available = startText.text.length - startOffset;
            var remaining = length;
            endOffset = startOffset + remaining;
            while (available < remaining && texts.length > 0) {
                endEntry = texts.shift();
                var endText_1 = endEntry[0];
                remaining = length - available;
                available = endText_1.text.length;
                endOffset = remaining;
            }
            var _b = endEntry, endText = _b[0], endPath = _b[1];
            if (typeof token !== 'string') {
                var decoration = {
                    type: token.type,
                    anchor: {
                        key: startText.key,
                        path: startPath,
                        offset: startOffset,
                    },
                    focus: {
                        key: endText.key,
                        path: endPath,
                        offset: endOffset,
                    },
                };
                decorations.push(decoration);
            }
            
        }
        return others.concat(decorations);
    };
    return {
        renderBlock: renderBlock,
        renderDecoration: renderDecoration,
        onKeyDown: onKeyDown,
        decorateNode: decorateNode,
    };
};

exports.default = coder;
//# sourceMappingURL=slate-coder.js.map
